char VisualizzaMenu(const char * menu[], char righe){
	// Variabile di gestione della scelta dell'utente
	char sel=0;
	// Variabile di gestione dell'aggiornamendo del LCD
	static bit Agg_LCD;
	Agg_LCD=1;
	
	do{
		// Aggiornare il LCD solo se necessario
		if (Agg_LCD){
			LCD_Write(LCD_CLEAR);
			
			if (sel < (righe-1)){
				// Visualizza elemento  sel  e il successivo
				LCD_Write('>');
				LCD_WriteString(menu[sel]);
				LCD_Write(' ');
				LCD_WriteString(menu[sel+1]);
			} else {
				// Visualizza gli ultimi 2 elementi
				LCD_Write(' ');
				LCD_WriteString(menu[sel-1]);
				LCD_Write('>');
				LCD_WriteString(menu[sel]);
			}
			
			// Aggiornamento LCD effettuato
			Agg_LCD=0;
			
			/* Esempio di output sul LCD      */
			// |>|O|G|G|E|T|T|O| |1| | | | | | |
			// | |O|G|G|E|T|T|O| |2| | | | | | |
		}
		
		// Attendi tra un input e il prossimo
		__delay_ms(B_INPUT_RIT);
		
		// Gestisci gli input
		if ((B_INPUT_DEC == 1) && (sel > 0)){
			sel--;
			
			// Richiesta di aggiornamento del LCD
			Agg_LCD=1;
		} else if ((B_INPUT_INC == 1) && (sel < (righe-1))){
			sel++;
			
			// Richiesta di aggiornamento del LCD
			Agg_LCD=1;
		}
	} while (!B_INPUT_SEL);
	
	// Pulitura del display
	LCD_Write(LCD_CLEAR);
	
	return sel; // riportare la voce selezionata
}

void ImpostaCalibrazione(){
	// Passo (in secondi) di calibrazione
	char SEC = eeprom_read(B_CALIB_SEC);
	char PAS = eeprom_read(B_CALIB_PAS);
	
	// Modifica del tempo totale di calibrazione
	LCD_Write(LCD_CLEAR);
	LCD_Write(LCD_DISPLAY_CONTROL(LCD_D,LCD_C,1));
	LCD_WriteString("IMPOSTARE TEMPO\nDEL PASSO     >>");
	LCD_Write(LCD_GOTO(0x4F));
	
	// Abilitazione del cursore lampeggiante
	LCD_Write(LCD_DISPLAY_CONTROL(LCD_D,LCD_C,1));
	
	// Attesa di "OK" da parte dell'utente
	do {
		__delay_ms(B_INPUT_RIT);
	} while(!B_INPUT_SEL);
	
	// Modifica del tempo del passo di calibrazione
	LCD_Write(LCD_CLEAR);
	LCD_WriteString("TEMPO DEL PASSO:\n      secondi");
	LCD_Write(LCD_GOTO(0x43));
	
	do {
		__delay_ms(B_INPUT_RIT);
		if (B_INPUT_DEC && (SEC > 5))
			SEC-=5;
		else if (B_INPUT_INC && (SEC < 30))
			SEC+=5;
		
		if (SEC < 10) LCD_Write(' ');
		LCD_WriteNumber(SEC);
		LCD_Write(LCD_GOTO(0x43));
	} while (!B_INPUT_SEL);
	
	eeprom_write(B_CALIB_SEC, SEC);
	
	// Modifica del passo di calibrazione
	LCD_Write(LCD_CLEAR);
	LCD_WriteString("IMPOSTARE \nNUMERO PASSI  >>");
	LCD_Write(LCD_GOTO(0x4F));
	
	// Attesa di "OK" da parte dell'utente
	do {
		__delay_ms(B_INPUT_RIT);
	} while(!B_INPUT_SEL);
	
	// Schermata iniziale
	// | | |N|U|M|E|R|O| |P|A|S|S|I| | |
	// | | | | | | |x|0|0| | | | | | | |
	LCD_Write(LCD_CLEAR);
	LCD_WriteString("  NUMERO PASSI");
	LCD_Write(LCD_GOTO(0x46));
	
	// Abilitazione del cursore lampeggiante
	LCD_Write(LCD_DISPLAY_CONTROL(LCD_D,LCD_C,1));
	do {
		__delay_ms(B_INPUT_RIT);
		if (B_INPUT_DEC && (PAS > 1))
			PAS--;
		else if (B_INPUT_INC && (PAS < 255))
			PAS++;
		
		if (PAS < 10) LCD_Write(' ');
		if (PAS < 100) LCD_Write(' ');
		LCD_WriteNumber(PAS);
		LCD_Write(LCD_GOTO(0x46));
	} while (!B_INPUT_SEL);
	
	// Disabilitazione del cursore lampeggiante
	LCD_Write(LCD_DISPLAY_CONTROL(LCD_D,LCD_C,0));
	
	// Salvataggio del passo di calibrazione
	eeprom_write(B_CALIB_PAS, PAS);
}

void ImpostaTimer(char aMIN, char aSEC){
	// Lettura del tempo attuale dalla EEPROM
	// agli indirizzi specificati nella chiamata
	char MIN = eeprom_read(aMIN);
	char SEC = eeprom_read(aSEC);
	
	do {
		// Schermata iniziale
		// | |M|I|N|U|T|I| |S|E|C|O|N|D|I| |
		// | | | |M|M| | | | | | |S|S| | | |
		LCD_Write(LCD_CLEAR);
		LCD_WriteString(" MINUTI SECONDI");
		
		LCD_Write(LCD_GOTO(0x43));
		if (MIN < 10) LCD_Write('0');
			LCD_WriteNumber(MIN);
		
		LCD_Write(LCD_GOTO(0x4B));
		if (SEC < 10) LCD_Write('0');
			LCD_WriteNumber(SEC);

		// Abilitazione del cursore lampeggiante
		LCD_Write(LCD_DISPLAY_CONTROL(LCD_D,LCD_C,1));
		
		// Modifica dei minuti
		LCD_Write(LCD_GOTO(0x43));
		do {
			__delay_ms(B_INPUT_RIT);
			if (B_INPUT_DEC && (MIN > 0))
				MIN--;
			else if (B_INPUT_INC && (MIN < 59))
				MIN++;
			
			if (MIN < 10) LCD_Write('0');
			LCD_WriteNumber(MIN);
			LCD_Write(LCD_GOTO(0x43));
		} while (!B_INPUT_SEL);
		
		// Modifica dei secondi
		LCD_Write(LCD_GOTO(0x4B));
		do {
			__delay_ms(B_INPUT_RIT);
			if (B_INPUT_DEC && (SEC > 0))
				SEC-=5;
			else if (B_INPUT_INC && (SEC < 55))
				SEC+=5;
			
			if (SEC < 10) LCD_Write('0');
			LCD_WriteNumber(SEC);
			LCD_Write(LCD_GOTO(0x4B));
		} while (!B_INPUT_SEL);
		
		// Disabilitazione del cursore lampeggiante
		LCD_Write(LCD_DISPLAY_CONTROL(LCD_D,LCD_C,0));
		
		// Controllo di validità del tempo
		if ((MIN == 0) && (SEC == 0)){
			LCD_Write(LCD_CLEAR);
			LCD_WriteString("    ERRORE!\nTEMPO NON VALIDO");
			__delay_ms(1500);
		}
	} while ((MIN == 0) && (SEC == 0)); // se MM:SS == 00:00, il tempo non è valido
	
	// Memorizzazione del nuovo tempo
	eeprom_write(aMIN, MIN);
	eeprom_write(aSEC, SEC);
}

bit Esposizione(char MIN, char SEC){
	// Variabile di gestione di annullamento
	// da parte dell'utente
	static bit annulla;
	annulla = 0;
	
	// Schermata iniziale
	// |T|E|M|P|O| |R|I|M|A|N|E|N|T|E| |
	// | | | | | |M|M|:|S|S| | | | | | |
	LCD_Write(LCD_CLEAR);
	LCD_WriteString("TEMPO RIMANENTE");
	LCD_Write(LCD_GOTO(0x45));
	if (MIN < 10) LCD_Write('0');
	LCD_WriteNumber(MIN);
	LCD_Write(':');
	if (SEC < 10) LCD_Write('0');
	LCD_WriteNumber(SEC);
	
	// Attivazione del timer TMR0
	INTCON = B_TIMER_ON;
	while (MIN || SEC) {
		if (B_INPUT_PAN == B_PAN_CH){
			// Il pannello di protezione è chiuso, proseguire
			
			// Accensione dei LED UV
			B_COM_UV1=1;
			B_COM_UV2=1;
			
			// Aggiornamento del timer sul display
			// viene attivato dal TMR0
			if (AGG_TIMER){
				if (SEC > 0) SEC--;
				else {
					SEC = 59;
					MIN--;
				}
				
				// Stampa del nuovo timer
				LCD_Write(LCD_GOTO(0x45));
				if (MIN < 10) LCD_Write('0');
				LCD_WriteNumber(MIN);
				LCD_Write(':');
				if (SEC < 10) LCD_Write('0');
				LCD_WriteNumber(SEC);
				
				// Aggiornamento del timer effettuato
				AGG_TIMER = 0;
			}
			
			// Gestione dell'annullamento dell'operazione
			// da parte dell'utente
			__delay_ms(B_INPUT_RIT);
			if (B_INPUT_SEL){
				// LED di stato: OFF (inattivo) | LED UV: OFF | TIMER: OFF (in sospeso)
				B_LED_STATO = 0;
				B_COM_UV1=0;
				B_COM_UV2=0;
				INTCON = B_TIMER_OFF;
				
				// Richiesta esplicita di annullamento
				LCD_Write(LCD_DISPLAY_CONTROL(LCD_D,LCD_C,1));
				LCD_Write(LCD_CLEAR);
				LCD_WriteString("Annullare l'\noperazione?  S/N");
				LCD_Write(LCD_GOTO(0x4F));
				do {
					if (B_INPUT_DEC){
						annulla=1;
						LCD_Write(LCD_GOTO(0x4D));
					} else if (B_INPUT_INC){
						annulla=0;
						LCD_Write(LCD_GOTO(0x4F));
					}
					__delay_ms(B_INPUT_RIT);
				} while (!B_INPUT_SEL);
				LCD_Write(LCD_DISPLAY_CONTROL(LCD_D,LCD_C,0));
				
				if (annulla){
					// Richiesta acconsentita, l'utente ha scelto "SI"
					// Interrompere la procedura facendo scadere il tempo rimasto
					MIN = 0;
					SEC = 0;
					break;
				} else {
					// Richiesta negata, l'utente ha scelto "NO"
					// Ripristino delle funzioni: LED UV: ON | TIMER: ON
					B_COM_UV1=1;
					B_COM_UV2=1;
					INTCON = B_TIMER_ON;
					
					// Ripristino della schermata del timer
					LCD_Write(LCD_CLEAR);
					LCD_WriteString("TEMPO RIMANENTE");
					LCD_Write(LCD_GOTO(0x45));
					if (MIN < 10) LCD_Write('0');
					LCD_WriteNumber(MIN);
					LCD_Write(':');
					if (SEC < 10) LCD_Write('0');
					LCD_WriteNumber(SEC);
				}
			}
			// Cambiamento del LED di stato
			// risulterà lampeggiante, duty cycle circa 50%
			B_LED_STATO = !B_LED_STATO;
			__delay_ms(B_INPUT_RIT);
		} else {
			// IL PANNELLO DI PROTEZIONE E' -> APERTO <-, NON PROSEGUIRE!!!
			// Sospensione delle funzioni
			// LED di stato: OFF (inattivo) | LED UV: OFF | TIMER: OFF (in sospeso)
			B_LED_STATO = 0;
			B_COM_UV1=0;
			B_COM_UV2=0;
			INTCON = B_TIMER_OFF;
			
			// Notifica all'utente
			LCD_Write(LCD_CLEAR);
			LCD_WriteString("ATTENZIONE:\nPANNELLO APERTO");
			while (B_INPUT_PAN == B_PAN_AP){
				__delay_ms(B_INPUT_RIT);
				
				// Gestione dell'annullamento dell'operazione
				// da parte dell'utente
				if (B_INPUT_SEL){
					// Richiesta esplicita di annullamento
					LCD_Write(LCD_DISPLAY_CONTROL(LCD_D,LCD_C,1));
					LCD_Write(LCD_CLEAR);
					LCD_WriteString("Annullare l'\noperazione?  S/N");
					LCD_Write(LCD_GOTO(0x4F));
					__delay_ms(B_INPUT_RIT);
					do {
						if (B_INPUT_DEC){
							annulla=1;
							LCD_Write(LCD_GOTO(0x4D));
						} else if (B_INPUT_INC){
							annulla=0;
							LCD_Write(LCD_GOTO(0x4F));
						}
						__delay_ms(B_INPUT_RIT);
					} while (!B_INPUT_SEL);
					LCD_Write(LCD_DISPLAY_CONTROL(LCD_D,LCD_C,0));
					
					if (annulla){
						// Richiesta acconsentita, l'utente ha scelto "SI"
						// Interrompere la procedura facendo scadere il tempo rimasto
						MIN = 0;
						SEC = 0;
						break;
					} else {
						// Richiesta negata, l'utente ha scelto "NO"
						// Ripristino della notifica sul pannello
						LCD_Write(LCD_CLEAR);
						LCD_WriteString("ATTENZIONE:\nPANNELLO APERTO");
					}
				}
			}
			LCD_Write(LCD_CLEAR);
			LCD_WriteString("TEMPO RIMANENTE");
			// Se l'utente ha scelto "NO", il tempo non è scaduto
			// Riprisitinare le funzioni vitali: LED UV: ON | TIMER: ON
			B_COM_UV1=1;
			B_COM_UV2=1;
			INTCON = B_TIMER_ON;
		}
	}
	
	// Procedura di esposizione completata
	// Disabilitazione delle funzioni
	// TIMER: OFF | LED UV: OFF | LED STATO: ON (pronto)
	B_LED_STATO = 1;
	B_COM_UV1=0;
	B_COM_UV2=0;
	INTCON = B_TIMER_OFF;
	
	// Pulitura del LCD
	LCD_Write(LCD_CLEAR);
	
	// Ritorno del tipo di terminazione
	// 0: terminata normalmente | 1: annullata dall'utente
	return annulla;
}

bit Calibrazione(){
	// Lettura dei parametri di calibrazione dalla EEPROM
	char PAS = eeprom_read(B_CALIB_PAS);
	char SEC = eeprom_read(B_CALIB_SEC);
	char c=0;
	
	static bit annulla;
	annulla=0;
	
	// Esecuzione dei passi di calibrazione
	// Esposizione di PAS secondi finché MIN e SEC
	// non sono 0, con stop ad ogni esecuzione
	while (c < PAS){
		// Notifica del passo prossimo all'esecuzione
		LCD_Write(LCD_CLEAR);
		LCD_WriteString("PASSO     SU    ");
		LCD_Write(LCD_GOTO(0x06));
		if (c < 9) LCD_Write(' ');
		if (c < 99) LCD_Write(' ');
		LCD_WriteNumber(c+1);
		LCD_Write(LCD_GOTO(0x0D));
		LCD_WriteNumber(PAS);
		LCD_WriteString("\nCONTINUA      >>");
		
		// Attesa di conferma con OK da parte dell'utente
		do{
			__delay_ms(B_INPUT_RIT);
		} while (!B_INPUT_SEL);
		
		// Inizio esposizione parziale
		annulla = Esposizione(0, SEC);
		
		// Ad ogni esposizione contare il passo effettuato
		c++;
		
		// Durante l'esposizione l'utente potrebbe aver annullato
		// Annullamento dell'intera procedura di calibrazione
		if (annulla)
			break;
	}
	
	// Pulitura del display
	LCD_Write(LCD_CLEAR);
	
	// Ritorno del tipo di terminazione
	// 0: terminata normalmente | 1: annullata dall'utente
	return annulla;
}
