/***********************************************************
* Software di gestione del bromografo                      *
* AUTORE: Cristinel Costachescu                            *
* VERSIONE: 1.4.2                                          *
***********************************************************/

/* Definizione dell'interfaccia di I/O */
/******* INPUT *******/
#define B_INPUT_DEC	RC1
#define B_INPUT_INC	RC3
#define B_INPUT_SEL	RC0
#define B_INPUT_PAN	RA5
#define B_INPUT_RIT	200  /* ms */

/******* OUTPUT ******/
#define B_LED_STATO	RC2	// LED di stato
#define B_COM_UV1	RA2	// Comando LED UV1
#define B_COM_UV2	RA3	// Comando LED UV2

/* Definizione delle impostazioni generali del bromografo */
#define B_TIMER_ON	0xA0
#define B_TIMER_OFF	0x00
#define B_PAN_AP	0x01
#define B_PAN_CH	0x00

/* Definizione di indirizzi di impostazioni nella memoria EEPROM */
// TIMER ESPOSIZIONE
#define B_TIMER_MIN	0x00
#define B_TIMER_SEC	0x01

// TIMER CALIBRAZIONE
#define B_CALIB_SEC	0x02
#define B_CALIB_PAS	0x03

/* Definizione delle funzioni di gestione del bromografo */
char VisualizzaMenu(const char * [], char);
void ImpostaCalibrazione();
void ImpostaTimer(char, char);
bit Esposizione(char, char);
bit Calibrazione();
